package blusunrize.immersiveengineering.common.items;

import blusunrize.immersiveengineering.api.tool.IInternalStorageItem;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.NonNullList;

public abstract class ItemInternalStorage extends ItemIEBase implements IInternalStorageItem 
{
	public ItemInternalStorage(String name, int stackSize, String... subNames)
	{
		super(name, stackSize, subNames);
	}
	
	@Override
	public NonNullList<ItemStack> getContainedItems(ItemStack stack)
	{
		NonNullList<ItemStack> stackList = NonNullList.func_191197_a(getInternalSlots(stack), ItemStack.field_190927_a);
		if(stack.func_77942_o())
		{
			NBTTagList inv = stack.func_77978_p().func_150295_c("Inv",10);
			for (int i=0; i<inv.func_74745_c(); i++)
			{
				NBTTagCompound tag = inv.func_150305_b(i);
				int slot = tag.func_74771_c("Slot") & 0xFF;
				if ((slot >= 0) && (slot < stackList.size()))
					stackList.set(slot, new ItemStack(tag));
			}
		}
		return stackList;
	}
	
	@Override
	public void setContainedItems(ItemStack stack, NonNullList<ItemStack> stackList)
	{
		NBTTagList inv = new NBTTagList();
		for (int i = 0; i < stackList.size(); i++)
			if (!stackList.get(i).func_190926_b())
			{
				NBTTagCompound tag = new NBTTagCompound();
				tag.func_74774_a("Slot", (byte)i);
				stackList.get(i).func_77955_b(tag);
				inv.func_74742_a(tag);
			}
		if(stack.func_77942_o())
		{
			NBTTagList invExisting = stack.func_77978_p().func_150295_c("Inv",10);
			for (int i=0; i<invExisting.func_74745_c(); i++)
			{
				NBTTagCompound tag = invExisting.func_150305_b(i);
				int slot = tag.func_74771_c("Slot") & 0xFF;
				if ((slot >= stackList.size()) && (slot < stackList.size()))
					inv.func_74742_a(tag);
			}
		}
		else
			stack.func_77982_d(new NBTTagCompound());
		stack.func_77978_p().func_74782_a("Inv",inv);
	}

	@Override
	public abstract int getInternalSlots(ItemStack stack);
}
